import "./style.css";
import { computed as G, reactive as z, onActivated as Y, watch as P, ref as $, resolveComponent as p, openBlock as j, createBlock as J, withCtx as N, createVNode as h, createElementVNode as f, toDisplayString as K, withDirectives as k, vShow as E } from "vue";
import { Grid as Q, GridColumn as W } from "@opentiny/vue";
import { PluginPanel as X, SvgButton as Z } from "@opentiny/tiny-engine-common";
import { constants as ee } from "@opentiny/tiny-engine-utils";
import { iconEyeopen as te, iconEyeclose as oe, IconChevronDown as ne } from "@opentiny/vue-icon";
import { useCanvas as u, useMaterial as re, useLayout as q } from "@opentiny/tiny-engine-meta-register";
import { extend as ce } from "@opentiny/vue-renderless/common/object";
import { typeOf as se } from "@opentiny/vue-renderless/common/type";
const ae = (i, o) => {
  const d = i.__vccOpts || i;
  for (const [n, g] of o)
    d[n] = g;
  return d;
}, { PAGE_STATUS: F } = ee, ie = {
  components: {
    TinyGrid: Q,
    TinyGridColumn: W,
    PluginPanel: X,
    SvgButton: Z,
    IconEyeopen: te(),
    IconEyeclose: oe()
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(i) {
    const { pageState: o, getInstance: d } = u(), { getMaterial: n } = re(), { PLUGIN_NAME: g } = q(), M = G(() => {
      var e;
      return (e = i.fixedPanels) == null ? void 0 : e.includes(g.OutlineTree);
    }), y = (e) => {
      const r = (a) => (a.forEach((s) => {
        s.show = o.nodesStatus[s.id] !== !1, s.showEye = !s.show;
        const w = s.children;
        se(w) !== "array" ? delete s.children : s.children.length && r(s.children);
      }), a);
      return [{ ...r([ce(!0, {}, e)])[0], componentName: "body" }];
    }, t = z({
      pageSchema: [],
      expandAll: !0,
      initSchema: [],
      isLock: G(
        () => ![F.Occupy, F.Guest].includes(q().layoutState.pageStatus.state)
      ),
      dragState: {
        allowDrop: !0,
        dragSchema: null,
        hoverVm: null,
        currentVm: null,
        parentNode: null,
        indicator: !0
      }
    });
    Y(() => {
      const { getSchema: e } = u().canvasApi.value;
      t.pageSchema = y(e());
    }), P(
      () => o.currentSchema,
      () => {
        const { getSchema: e } = u().canvasApi.value;
        t.pageSchema = y(e());
      }
    );
    const x = () => {
      t.expandAll = !t.expandAll;
    }, b = (e) => {
      e.show = !e.show, o.nodesStatus[e.id] = e.show;
      const { getRenderer: r, clearSelect: a } = u().canvasApi.value;
      r().setCondition(e.id, e.show), a();
    }, A = (e) => e.componentName ? n(e.componentName).icon || "IconAssociation" : void 0, I = (e) => {
      if (t.isLock)
        return;
      const { hoverNode: r } = u().canvasApi.value;
      r(e.id), e.showEye = !0;
    }, c = (e) => {
      e && !e.show || (e.showEye = !1);
    }, _ = (e) => {
      if (t.isLock)
        return;
      const { selectNode: r } = u().canvasApi.value;
      r(e == null ? void 0 : e.id, "clickTree");
    }, m = $(null), O = () => {
    }, R = ({ row: e }) => {
      var a;
      return "nav-tree " + (((a = o == null ? void 0 : o.currentSchema) == null ? void 0 : a.id) === e.id ? "high-light-node" : "");
    }, V = (e, r) => {
      var D;
      e.dragged.classList.remove("nodrag");
      const { clientY: a } = r, s = e.draggedRect.bottom, w = Math.abs(a - s), C = e.dragged.querySelector(".tree-box").getAttribute("type"), B = e.dragged.querySelector(".tree-box").getAttribute("schemaId"), S = d(B);
      t.dragState.dragSchema = S;
      const T = e.related.querySelector(".tree-box").getAttribute("type"), U = e.related.querySelector(".tree-box").getAttribute("schemaId"), l = d(U);
      o.hoverVm = l;
      const v = (D = S == null ? void 0 : S.componentName) == null ? void 0 : D.container, H = l == null ? void 0 : l.parent.schema.componentName;
      C === "col" && v && T !== "col" || C === "col" && !v && H !== "row" || C !== "col" && v && T === "row" ? t.dragState.indicator = !1 : l ? t.dragState.indicator = !0 : t.dragState.indicator = !1, t.dragState.indicator ? (e.dragged.classList.remove("nodrag"), t.dragState.allowDrop = !0) : (e.dragged.classList.add("nodrag"), t.dragState.allowDrop = !1);
      const L = r.target;
      w < 4 && w > 1 && v && (!l.schema.children || l.schema.children.length === 0) && (t.dragState.parentNode = L, L.querySelector(".tiny-grid-tree-wrapper").innerHTML = '<i class="tiny-grid-tree__node-btn tiny-grid-icon__caret-right"></i>'), t.dragState.parentNode && t.dragState.parentNode.getAttribute("data-rowid") !== L.getAttribute("data-rowid") && (t.dragState.parentNode.querySelector(".tiny-grid-tree-wrapper").innerHTML = "", t.dragState.parentNode = null);
    };
    return P(
      () => o.isLock,
      (e) => {
        setTimeout(O, 1e3), t.isLock = e;
      }
    ), {
      panelFixed: M,
      checkElement: _,
      mouseover: I,
      mouseleave: c,
      showNode: b,
      state: t,
      getIcon: A,
      rowDropMove: V,
      gridRef: m,
      toggleTree: x,
      getClassName: R,
      PLUGIN_NAME: g,
      renderIconFn: (e, { isActive: r }) => e(ne(), {
        class: ["tiny-grid-tree__node-btn", { is__active: r }]
      })
    };
  }
}, le = { class: "tree-wrap lowcode-scrollbar" }, de = ["schemaId", "type", "onMouseover", "onMouseleave", "onClick"], pe = { class: "tree-content" }, ue = ["onMouseup"];
function ge(i, o, d, n, g, M) {
  const y = p("svg-button"), t = p("icon-eyeopen"), x = p("icon-eyeclose"), b = p("tiny-grid-column"), A = p("tiny-grid"), I = p("plugin-panel");
  return j(), J(I, {
    class: "outlinebox",
    title: "大纲树",
    onClose: o[1] || (o[1] = (c) => i.$emit("close"))
  }, {
    header: N(() => [
      h(y, {
        class: "item icon-sidebar",
        name: n.panelFixed ? "fixed-solid" : "fixed",
        tips: n.panelFixed ? "解除固定面板" : "固定面板",
        onClick: o[0] || (o[0] = (c) => i.$emit("fix-panel", n.PLUGIN_NAME.OutlineTree))
      }, null, 8, ["name", "tips"])
    ]),
    content: N(() => [
      f("div", le, [
        h(A, {
          ref: "gridRef",
          data: n.state.pageSchema,
          "tree-config": { children: "children", expandAll: n.state.expandAll, renderIcon: n.renderIconFn },
          "show-header": !1,
          "highlight-hover-row": !1,
          "auto-resize": !0,
          "row-class-name": n.getClassName
        }, {
          default: N(() => [
            h(b, {
              field: "componentName",
              "tree-node": ""
            }, {
              default: N((c) => {
                var _;
                return [
                  f("span", {
                    class: "tree-box",
                    schemaId: (_ = c.row) == null ? void 0 : _.id,
                    type: c.row.componentName,
                    onMouseover: (m) => n.mouseover(c.row),
                    onMouseleave: (m) => n.mouseleave(c.row),
                    onClick: (m) => n.checkElement(c.row)
                  }, [
                    f("span", pe, [
                      f("span", null, K(c.row.componentName), 1)
                    ]),
                    k(f("span", {
                      class: "tree-handle",
                      onMouseup: (m) => n.showNode(c.row)
                    }, [
                      k(h(t, null, null, 512), [
                        [E, c.row.show]
                      ]),
                      k(h(x, null, null, 512), [
                        [E, !c.row.show]
                      ])
                    ], 40, ue), [
                      [E, c.row.showEye]
                    ])
                  ], 40, de)
                ];
              }),
              _: 1
            })
          ]),
          _: 1
        }, 8, ["data", "tree-config", "row-class-name"])
      ])
    ]),
    _: 1
  });
}
const me = /* @__PURE__ */ ae(ie, [["render", ge], ["__scopeId", "data-v-4f3c1b3f"]]), he = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  align: "top"
}, Ie = {
  ...he,
  entry: me
};
export {
  Ie as default
};
